/// @cond EO_CXX_EO_IMPL

inline void elm::index::level_go(int level_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_index_level_go(level_));
}

inline ::elm::widget_item elm::index::item_prepend(::efl::eina::string_view letter_, Evas_Smart_Cb func_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_item_prepend(::efl::eolian::to_c(letter_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::index::item_clear() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_index_item_clear());
}

inline ::elm::widget_item elm::index::item_insert_after(::elm::widget_item after_, ::efl::eina::string_view letter_, Evas_Smart_Cb func_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_item_insert_after(::efl::eolian::to_c(after_), ::efl::eolian::to_c(letter_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::index::item_find(const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_item_find(data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::index::item_insert_before(::elm::widget_item before_, ::efl::eina::string_view letter_, Evas_Smart_Cb func_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_item_insert_before(::efl::eolian::to_c(before_), ::efl::eolian::to_c(letter_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::index::item_append(::efl::eina::string_view letter_, Evas_Smart_Cb func_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_item_append(::efl::eolian::to_c(letter_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::index::selected_item_get(int level_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_selected_item_get(level_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::index::item_sorted_insert(::efl::eina::string_view letter_, Evas_Smart_Cb func_, const void * data_, Eina_Compare_Cb cmp_func_, Eina_Compare_Cb cmp_data_func_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_item_sorted_insert(::efl::eolian::to_c(letter_), func_, data_, cmp_func_, cmp_data_func_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool elm::index::autohide_disabled_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_autohide_disabled_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::index::autohide_disabled_set(bool disabled_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_index_autohide_disabled_set(::efl::eolian::to_c(disabled_)));
}

inline bool elm::index::omit_enabled_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_omit_enabled_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::index::omit_enabled_set(bool enabled_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_index_omit_enabled_set(::efl::eolian::to_c(enabled_)));
}

inline int elm::index::standard_priority_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_standard_priority_get());
   return _tmp_ret;
}

inline void elm::index::standard_priority_set(int priority_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_index_standard_priority_set(priority_));
}

inline bool elm::index::horizontal_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_horizontal_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::index::horizontal_set(bool horizontal_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_index_horizontal_set(::efl::eolian::to_c(horizontal_)));
}

inline double elm::index::delay_change_time_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_delay_change_time_get());
   return _tmp_ret;
}

inline void elm::index::delay_change_time_set(double dtime_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_index_delay_change_time_set(dtime_));
}

inline bool elm::index::indicator_disabled_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_indicator_disabled_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::index::indicator_disabled_set(bool disabled_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_index_indicator_disabled_set(::efl::eolian::to_c(disabled_)));
}

inline int elm::index::item_level_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_item_level_get());
   return _tmp_ret;
}

inline void elm::index::item_level_set(int level_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_index_item_level_set(level_));
}

inline void eo_cxx::elm::index::level_go(int level_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_index_level_go(level_));
}

inline ::elm::widget_item eo_cxx::elm::index::item_prepend(::efl::eina::string_view letter_, Evas_Smart_Cb func_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_item_prepend(::efl::eolian::to_c(letter_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::index::item_clear() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_index_item_clear());
}

inline ::elm::widget_item eo_cxx::elm::index::item_insert_after(::elm::widget_item after_, ::efl::eina::string_view letter_, Evas_Smart_Cb func_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_item_insert_after(::efl::eolian::to_c(after_), ::efl::eolian::to_c(letter_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::index::item_find(const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_item_find(data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::index::item_insert_before(::elm::widget_item before_, ::efl::eina::string_view letter_, Evas_Smart_Cb func_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_item_insert_before(::efl::eolian::to_c(before_), ::efl::eolian::to_c(letter_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::index::item_append(::efl::eina::string_view letter_, Evas_Smart_Cb func_, const void * data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_item_append(::efl::eolian::to_c(letter_), func_, data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::index::selected_item_get(int level_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_selected_item_get(level_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::index::item_sorted_insert(::efl::eina::string_view letter_, Evas_Smart_Cb func_, const void * data_, Eina_Compare_Cb cmp_func_, Eina_Compare_Cb cmp_data_func_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_item_sorted_insert(::efl::eolian::to_c(letter_), func_, data_, cmp_func_, cmp_data_func_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::elm::index::autohide_disabled_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_autohide_disabled_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::index::autohide_disabled_set(bool disabled_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_index_autohide_disabled_set(::efl::eolian::to_c(disabled_)));
}

inline bool eo_cxx::elm::index::omit_enabled_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_omit_enabled_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::index::omit_enabled_set(bool enabled_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_index_omit_enabled_set(::efl::eolian::to_c(enabled_)));
}

inline int eo_cxx::elm::index::standard_priority_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_standard_priority_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::index::standard_priority_set(int priority_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_index_standard_priority_set(priority_));
}

inline bool eo_cxx::elm::index::horizontal_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_horizontal_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::index::horizontal_set(bool horizontal_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_index_horizontal_set(::efl::eolian::to_c(horizontal_)));
}

inline double eo_cxx::elm::index::delay_change_time_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_delay_change_time_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::index::delay_change_time_set(double dtime_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_index_delay_change_time_set(dtime_));
}

inline bool eo_cxx::elm::index::indicator_disabled_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_indicator_disabled_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::index::indicator_disabled_set(bool disabled_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_index_indicator_disabled_set(::efl::eolian::to_c(disabled_)));
}

inline int eo_cxx::elm::index::item_level_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_item_level_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::index::item_level_set(int level_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_index_item_level_set(level_));
}

inline ::eo_cxx::elm::index::operator ::elm::index() const
{
   return *static_cast<::elm::index const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::index::operator ::elm::index&()
{
   return *static_cast<::elm::index*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::index::operator ::elm::index const&() const
{
   return *static_cast<::elm::index const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_index_level_go_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int level_)
{
   try
      {
         static_cast<T*>(self->this_)->level_go(level_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::elm::widget_item elm_index_item_prepend_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * letter_, Evas_Smart_Cb func_, const void * data_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_prepend(::efl::eolian::to_cxx<::efl::eina::string_view>(letter_, std::tuple<std::false_type>()), func_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_index_item_clear_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->item_clear();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::elm::widget_item elm_index_item_insert_after_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Widget_Item * after_, const char * letter_, Evas_Smart_Cb func_, const void * data_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_insert_after(::efl::eolian::to_cxx<::elm::widget_item>(after_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::efl::eina::string_view>(letter_, std::tuple<std::false_type>()), func_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_index_item_find_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const void * data_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_find(data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_index_item_insert_before_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Widget_Item * before_, const char * letter_, Evas_Smart_Cb func_, const void * data_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_insert_before(::efl::eolian::to_cxx<::elm::widget_item>(before_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::efl::eina::string_view>(letter_, std::tuple<std::false_type>()), func_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_index_item_append_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * letter_, Evas_Smart_Cb func_, const void * data_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_append(::efl::eolian::to_cxx<::efl::eina::string_view>(letter_, std::tuple<std::false_type>()), func_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_index_selected_item_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int level_)
{
   try
      {
         return static_cast<T*>(self->this_)->selected_item_get(level_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_index_item_sorted_insert_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * letter_, Evas_Smart_Cb func_, const void * data_, Eina_Compare_Cb cmp_func_, Eina_Compare_Cb cmp_data_func_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_sorted_insert(::efl::eolian::to_cxx<::efl::eina::string_view>(letter_, std::tuple<std::false_type>()), func_, data_, cmp_func_, cmp_data_func_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
bool elm_index_autohide_disabled_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->autohide_disabled_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_index_autohide_disabled_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool disabled_)
{
   try
      {
         static_cast<T*>(self->this_)->autohide_disabled_set(::efl::eolian::to_cxx<bool>(disabled_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_index_omit_enabled_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->omit_enabled_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_index_omit_enabled_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool enabled_)
{
   try
      {
         static_cast<T*>(self->this_)->omit_enabled_set(::efl::eolian::to_cxx<bool>(enabled_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
int elm_index_standard_priority_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->standard_priority_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         int _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_index_standard_priority_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int priority_)
{
   try
      {
         static_cast<T*>(self->this_)->standard_priority_set(priority_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_index_horizontal_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->horizontal_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_index_horizontal_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool horizontal_)
{
   try
      {
         static_cast<T*>(self->this_)->horizontal_set(::efl::eolian::to_cxx<bool>(horizontal_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
double elm_index_delay_change_time_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->delay_change_time_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         double _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_index_delay_change_time_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double dtime_)
{
   try
      {
         static_cast<T*>(self->this_)->delay_change_time_set(dtime_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_index_indicator_disabled_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->indicator_disabled_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_index_indicator_disabled_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool disabled_)
{
   try
      {
         static_cast<T*>(self->this_)->indicator_disabled_set(::efl::eolian::to_cxx<bool>(disabled_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
int elm_index_item_level_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->item_level_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         int _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_index_item_level_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int level_)
{
   try
      {
         static_cast<T*>(self->this_)->item_level_set(level_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::index >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
         , virtual operations< ::evas::clickable_interface >::template type<T>
         , virtual operations< ::evas::selectable_interface >::template type<T>
   {
      virtual void level_go(int level_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_index_level_go(level_));
      }

      virtual ::elm::widget_item item_prepend(::efl::eina::string_view letter_, Evas_Smart_Cb func_, const void * data_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_index_item_prepend(::efl::eolian::to_c(letter_), func_, data_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void item_clear()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_index_item_clear());
      }

      virtual ::elm::widget_item item_insert_after(::elm::widget_item after_, ::efl::eina::string_view letter_, Evas_Smart_Cb func_, const void * data_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_index_item_insert_after(::efl::eolian::to_c(after_), ::efl::eolian::to_c(letter_), func_, data_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item item_find(const void * data_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_index_item_find(data_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item item_insert_before(::elm::widget_item before_, ::efl::eina::string_view letter_, Evas_Smart_Cb func_, const void * data_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_index_item_insert_before(::efl::eolian::to_c(before_), ::efl::eolian::to_c(letter_), func_, data_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item item_append(::efl::eina::string_view letter_, Evas_Smart_Cb func_, const void * data_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_index_item_append(::efl::eolian::to_c(letter_), func_, data_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item selected_item_get(int level_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_index_selected_item_get(level_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item item_sorted_insert(::efl::eina::string_view letter_, Evas_Smart_Cb func_, const void * data_, Eina_Compare_Cb cmp_func_, Eina_Compare_Cb cmp_data_func_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_index_item_sorted_insert(::efl::eolian::to_c(letter_), func_, data_, cmp_func_, cmp_data_func_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool autohide_disabled_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_index_autohide_disabled_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void autohide_disabled_set(bool disabled_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_index_autohide_disabled_set(::efl::eolian::to_c(disabled_)));
      }

      virtual bool omit_enabled_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_index_omit_enabled_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void omit_enabled_set(bool enabled_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_index_omit_enabled_set(::efl::eolian::to_c(enabled_)));
      }

      virtual int standard_priority_get()
      {
         int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_index_standard_priority_get());
            return _tmp_ret;
      }

      virtual void standard_priority_set(int priority_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_index_standard_priority_set(priority_));
      }

      virtual bool horizontal_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_index_horizontal_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void horizontal_set(bool horizontal_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_index_horizontal_set(::efl::eolian::to_c(horizontal_)));
      }

      virtual double delay_change_time_get()
      {
         double _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_index_delay_change_time_get());
            return _tmp_ret;
      }

      virtual void delay_change_time_set(double dtime_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_index_delay_change_time_set(dtime_));
      }

      virtual bool indicator_disabled_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_index_indicator_disabled_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void indicator_disabled_set(bool disabled_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_index_indicator_disabled_set(::efl::eolian::to_c(disabled_)));
      }

      virtual int item_level_get()
      {
         int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_index_item_level_get());
            return _tmp_ret;
      }

      virtual void item_level_set(int level_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_index_item_level_set(level_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::index >
{
   static constexpr int value = 
#if defined(INDEX_PROTECTED) && defined(INDEX_BETA)
      23
#elif defined(INDEX_PROTECTED)
      23
#elif defined(INDEX_BETA)
      23
#else
      23
#endif
      + operation_description_class_size<::elm::layout >::value      + operation_description_class_size<::evas::clickable_interface >::value      + operation_description_class_size<::evas::selectable_interface >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::index>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_index_level_go_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_level_go);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_index_item_prepend_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_item_prepend);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_index_item_clear_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_item_clear);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_index_item_insert_after_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_item_insert_after);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_index_item_find_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_item_find);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_index_item_insert_before_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_item_insert_before);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_index_item_append_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_item_append);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_index_selected_item_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_selected_item_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_index_item_sorted_insert_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_item_sorted_insert);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_index_autohide_disabled_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_autohide_disabled_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_index_autohide_disabled_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_autohide_disabled_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_index_omit_enabled_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_omit_enabled_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_index_omit_enabled_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_omit_enabled_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_index_standard_priority_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_standard_priority_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_index_standard_priority_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_standard_priority_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_index_horizontal_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_horizontal_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_index_horizontal_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_horizontal_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_index_delay_change_time_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_delay_change_time_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_index_delay_change_time_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_delay_change_time_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_index_indicator_disabled_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_indicator_disabled_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_index_indicator_disabled_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_indicator_disabled_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_index_item_level_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_item_level_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_index_item_level_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_item_level_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::index >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::clickable_interface>(), &ops[operation_description_class_size< ::elm::index >::value + operation_description_class_size<::elm::layout>::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::selectable_interface>(), &ops[operation_description_class_size< ::elm::index >::value + operation_description_class_size<::elm::layout>::value + operation_description_class_size<::evas::clickable_interface>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::index>)
{
   return (ELM_INDEX_CLASS);
}

} } }

/// @endcond

